import java.awt.BasicStroke;
import java.awt.Color;
import java.awt.Font;
import java.awt.Graphics;
import java.awt.Graphics2D;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.io.File;
import java.io.FileWriter;
import java.io.IOException;

import javax.swing.JButton;
import javax.swing.JOptionPane;
import javax.swing.JPanel;

public class DrawEmptyObkJPanel extends JPanel implements ActionListener {
	private ControlBoard controlBoardFrame;
	private DrawEmptyObkFrame frame;
	private EmptyOrderBooksList emptyOrderBooksList; 
	private Log appLog; 
	int OFFSET = 50;
	int POINT_SIZE = 5;
	int x, y, previousX, previousY = OFFSET;
	int SIZE_FACTOR = 2;
	int scaleX = 1;
	int scaleY = 3;
 	int x0 = 0;
 	int y0 = 0;
 
	float X_INCREASE_FACTOR = 3;
	float Y_INCREASE_FACTOR = 1;
	int x0_Chart = OFFSET;
	int y0_Chart = OFFSET;
 
	Graphics2D g2d = null;
	int nbSec = 0;
 	   
    JButton buttonPlus_X, buttonMinus_X, buttonPlus_Y, buttonMinus_Y, buttonReset, button_AddRemove_AllPlayers;
 
	// ***************
	// constructor
	// ***************
	public DrawEmptyObkJPanel(ControlBoard controlBoardFrame, DrawEmptyObkFrame frame, EmptyOrderBooksList emptyOrderBooksList, Log appLog) {
		this.controlBoardFrame = controlBoardFrame;
		this.frame = frame;
		this.emptyOrderBooksList = emptyOrderBooksList;
		this.appLog = appLog;
		
	    // listOfPlayersGraphs = new ListOfPlayersGraphs();

	     buttonPlus_X = new JButton("X +"); 
	     buttonMinus_X = new JButton("X -");
	     buttonPlus_Y = new JButton("Y +");
	     buttonMinus_Y = new JButton("Y -");
	     buttonReset = new JButton("Reset zoom");
	     button_AddRemove_AllPlayers = new JButton("+/- All Players"); 

	     this.add(buttonPlus_X); buttonPlus_X.addActionListener(this);
	   	 this.add(buttonMinus_X); buttonMinus_X.addActionListener(this);
	   	 this.add(buttonPlus_Y);  buttonPlus_Y.addActionListener(this);
	   	 this.add(buttonMinus_Y); buttonMinus_Y.addActionListener(this);
	   	 this.add(buttonReset); 	 buttonReset.addActionListener(this);
	}
	   

	@Override
	public void actionPerformed(ActionEvent e) {
		if (e.getSource()==buttonPlus_X) {
			X_INCREASE_FACTOR = X_INCREASE_FACTOR*2;
			this.repaint();
			}
		
		if (e.getSource()==buttonMinus_X) {
			//if (X_INCREASE_FACTOR >= 2
			X_INCREASE_FACTOR = X_INCREASE_FACTOR/2;
			this.repaint();
			}
		
		if (e.getSource()==buttonPlus_Y) {
			Y_INCREASE_FACTOR = Y_INCREASE_FACTOR*2;
			this.repaint();
			}
		
		if (e.getSource()==buttonMinus_Y) {
			//if (Y_INCREASE_FACTOR >= 2) 
			Y_INCREASE_FACTOR = Y_INCREASE_FACTOR/2;
			this.repaint();
			}
		
		if (e.getSource()==buttonReset) {
			SIZE_FACTOR = 2;
			X_INCREASE_FACTOR = 3;
			Y_INCREASE_FACTOR = 1;
			scaleX = 1;
			scaleY = 1;
			this.repaint();
			}	
	
	}
	 
	   // ***********************************************************
	   //  drawLoad
	   // 
	   // ***********************************************************
	    void drawLoad(Graphics g) {

			// bigger black Font
	    	g2d = (Graphics2D) g;
	    	g2d.setPaint(Color.black);	    	
	    	g2d.setStroke(new BasicStroke(2));
			Font stringFont = new Font( "SansSerif", Font.BOLD, 13);
	    	g2d.setFont(stringFont);
	    	
	    	this.frame.setTitle("Empty Order Books chart - " + Globals.connectedUserName);

          // Y axis

	        String sCurrentCount =""; // string to display the last point X,Y values
	       
	        // point 0
			x0 = OFFSET+POINT_SIZE/3;
			y0 = this.getHeight()-OFFSET;
			nbSec = 0;
   	
	    	initChart(g2d,x0,y0);
			
	        if (emptyOrderBooksList != null) {
	    		// initialize chart
	        	if (emptyOrderBooksList.itemNbInList > 0) {
	        		// at least one empty obk data/item

	   		 g2d.setStroke(new BasicStroke(2));
	
	 	   	
	         //	draw lines between all points
	         int pointNb = 1;
	         int previousPointX = 0;
	         int currentPointX 	= 0;
	         int previousPointY = 0;
	         int currentPointY 	= 0;
	
	    	 // draw the chart
	         int max = this.emptyOrderBooksList.nbEmptyObkMax;
	         
	        for (EmptyOrderBook nextEmptyObk : this.emptyOrderBooksList.emptyOrderBooksList) {
	        	g2d.setPaint(Color.blue);
	    	
	    		nbSec = (int)(nextEmptyObk.elapsedTimeMsSinceStart/ 1e9);
	            
	            int displaySpeedFactor = 3;
	            currentPointX = nbSec;
	            currentPointY = nextEmptyObk.nbEmptyObk;
	    		
	        	if (pointNb == 1) {
	        		// draw a single point and not a line for the 1st point
	        		previousPointX = currentPointX;
	        		previousPointY = currentPointY;
	        	}
		
	        	// chart point
//	        	int x1 = x0 + X_INCREASE_FACTOR*(previousPointX-x0)/scaleX;
//	        	int x2 = x0 + X_INCREASE_FACTOR*(currentPointX-x0)/scaleX;   	
//	        	int y1 = y0 - Y_INCREASE_FACTOR*(y0-previousPointY)/scaleY;
//	        	int y2 = y0 - Y_INCREASE_FACTOR*(y0-currentPointY)/scaleY;
	        	
	        	int x1_Chart = this.getXChart(previousPointX);
	        	int x2_Chart = this.getXChart(currentPointX);   	
	        	int y1_Chart = this.getYChart(previousPointY);
	        	int y2_Chart = this.getYChart(currentPointY);
	        	
	        	g2d.drawLine(x1_Chart, y1_Chart, x2_Chart, y2_Chart);

	        	// only display with the last point (to avoid having overlapping values
	        	if (pointNb == this.emptyOrderBooksList.emptyOrderBooksList.size()) {
	        		
					// X = TIME
					g2d.setFont( new Font( "SansSerif", Font.BOLD, 14) );
					sCurrentCount = "X: " +(nbSec)/60+ " mns (" + (nbSec) + " sec)";
					g2d.drawString(sCurrentCount, 3*this.getWidth()/4, this.getHeight()-33);
					sCurrentCount = "Scale =" + String.format("%.1f",X_INCREASE_FACTOR/scaleX);
					g2d.setFont( new Font( "SansSerif", Font.PLAIN, 14) );
					g2d.drawString(sCurrentCount, 3*this.getWidth()/4, this.getHeight()-15);
					
					g2d.setFont( new Font( "SansSerif", Font.PLAIN, 14) );
					sCurrentCount = "scale = " + String.format("%.1f",Y_INCREASE_FACTOR/scaleY);
					g2d.drawString(sCurrentCount,OFFSET +10, 70+20);


	        		// draw current count next to the  last chart point
					g2d.setFont( new Font( "SansSerif", Font.BOLD, 14) );
	        		g2d.drawString(Integer.toString(nextEmptyObk.nbEmptyObk) , x2_Chart+10, y2_Chart);
	        		// axis indications
	        		g2d.drawString(Integer.toString(nextEmptyObk.nbEmptyObk) , x2_Chart+10, y2_Chart);
	        		g2d.drawString("Max="+Integer.toString(max) , x0+10, this.getYChart(max)-20);
	        		g2d.drawString(Integer.toString(nextEmptyObk.nbEmptyObk) , x0-30, y2_Chart);
	        	}
	
	        	// current point becomes previous point (to draw the next line)
	    		previousPointX = currentPointX;
	    		previousPointY = currentPointY;
	
	    		pointNb++;	
	          	}
	        }
	     }
   }	        	
	    
		// ***************************************************
		// *** recalculate parameters to see the full chart
		// ***************************************************
	    public void reframeChart(EmptyOrderBook emptyOrderBook) {
	    	boolean bScaleChange = false;
            // ********************************************************
            // reframe the graph if it's getting too close to borders
    		// ********************************************************
            // resize X
            int resizeTrials = 1;
            int xTemp = x;

            // adjust scale X until the new point stays within the graph boundaries
    		while ((x0+(xTemp-x0)/scaleX)>(this.getWidth()-4*OFFSET) ) { 
    			bScaleChange = true;
    	        if (bScaleChange == true) {
    	        		//displayChart (g2d, true, Color.lightGray, appLog);
    	        		initChart(g2d,x0,y0);
    	        }
    			resizeTrials++;
    			if (resizeTrials>10000) break;
    			//appLog.logger.info("Draw point determine scaleX apply Size Factor: old xTemp = " + xTemp + " (x=" + x + ") scaleX = "+scaleX);
				// recalculate all points applying the new factor to get a smaller curve
				//recalculateGraphPointsListValues (x0, y0, SIZE_FACTOR);        			
				
				// recalculate current point with the new size factor
				scaleX = scaleX*SIZE_FACTOR;    				
				xTemp = x0+(xTemp-x0)/scaleX ;
	            //appLog.logger.info("Draw point apply Size Factor: newxTempx = " + xTemp + " scaleX = "+scaleX);
    		}
    		// resize Y
            resizeTrials = 1;
            int yTemp = y;
    		while ( (y0 - (y0-yTemp)/scaleY)<OFFSET ) {
    			bScaleChange = true;
    	        if (bScaleChange == true) {
    	        		//displayChart (g2d, true, Color.lightGray, appLog);
    	        		initChart(g2d,x0,y0);
    	        }
    			resizeTrials++;
    			if (resizeTrials>10000) break;
    			//appLog.logger.info("Draw point apply Size Factor: resizeTrials= " + resizeTrials + " old yTemp = "+ yTemp + " (y=" + y + ") scaleY = "+scaleY);
				// recalculate all points applying the new factor to get a smaller curve
				//recalculateGraphPointsListValues (x0, y0, SIZE_FACTOR);        			
				
				// recalculate current point with the new size factor
				scaleY = scaleY*SIZE_FACTOR;    				
				yTemp = y0-(y0-yTemp)/scaleY;
	           // appLog.logger.info("Draw point apply Size Factor: new yTemp = "+ yTemp + " scaleY = "+scaleY);
    		}
    		// scale X and Y are determined
  }
      	    
		// ***************************************************
		// *** initialize the chart
		// ***************************************************    
		public void initChart(Graphics2D g2d, int x0, int y0) {
	        int x1,y1,x2,y2 = 0;
	        
		   	g2d.setPaint(Color.black);
	        // Draw X axis
	        x1 = OFFSET;
	        x2 = this.getWidth()-OFFSET-10;
	        y1 = this.getHeight()-OFFSET;
	        y2 = y1;
	        g2d.drawLine(x1, y1, x2, y2);
	        
		   	// Draw Y axis
	        x1 = OFFSET;
	        x2 = x1;
	        y1 = this.getHeight()-OFFSET;
	        y2 = OFFSET;
	        g2d.drawLine(x1, y1, x2, y2);
	        
	        // display scale
	        g2d.drawString("0", x0-13, y0+5 );
	       // g2d.drawString( Integer.toString((this.getHeight()-OFFSET)*scaleY), x0-30, 70 );
	        // g2d.drawLine(x0-5,70,x0+5,70);
	        
			x = x0;
			y = y0;
			
		}
		// ***************************************************
		// *** to resize the chart
		// ***************************************************    
	    public void IncreaseScaleY( ) {
	    	this.scaleY = this.scaleY*2;
	    }	    
	 	// ***************************************************
	 	// *** getXChart
	 	// ***************************************************
	    public int getXChart(int X) {
	    	int XChart = (int)(x0_Chart + (int)(X_INCREASE_FACTOR*(X/scaleX))) ;
	    	return XChart;
	    }
	 	// ***************************************************
	 	// *** getYChart
	 	// ***************************************************
	    public int getYChart(int Y) {
	    	
	    	int YChart = (int)((this.getHeight() - y0_Chart) - ((Y * Y_INCREASE_FACTOR)/scaleY)) ;
	    	//System.out.println("this.getHeight() = "+ this.getHeight() + " y0_Chart = "+ y0_Chart + " Y = "+ Y + " Y_INCREASE_FACTOR= " + Y_INCREASE_FACTOR  + " result =" + YChart);
	    	return YChart;
	    }
    
	 	// ***************************************************
	 	// *** paintComponent
	 	// ***************************************************	
		protected void paintComponent(Graphics g) {
			super.paintComponent(g);
	        drawLoad(g);
	     }	
	
}
