import java.io.File;
import java.io.FileWriter;
import java.io.IOException;
import java.text.SimpleDateFormat;
import java.util.Date;
import java.util.ListIterator;
import java.util.concurrent.CopyOnWriteArrayList;

import javax.swing.JOptionPane;

public class EmptyOrderBooksList {
	public CopyOnWriteArrayList<EmptyOrderBook> emptyOrderBooksList = new CopyOnWriteArrayList<>();
	private SimpleDateFormat sdf = new SimpleDateFormat("yyy/MM/dd HH:mm:ss.sss") ;
	public int itemNbInList = 0;
	public long startTime = System.nanoTime();
	public int nbEmptyObkMax = 0; // max recorded nb of obks
	private Log appLog;
	
	private final static String FILE_EMPTY_OBK_POINTS_NAME = "Empty Order Books Data.csv";
	private final static String NEW_LINE_SEPARATOR ="\n";
	private final static String CSV_SEPARATOR =";";
	private final static String FILE_EMPTY_OBK_POINTS_HEADER =
														"Time" + CSV_SEPARATOR
														+ "#" + CSV_SEPARATOR
														+ "Nb empty obk" 
														+ NEW_LINE_SEPARATOR;	
	
	// constructor
	public EmptyOrderBooksList(Log appLog) {
		this.appLog = appLog;
		
	}
	// ***************************************************
	// *** Add a new point to the list
	// ***************************************************
	public void AddEmptyObk(int nbEmptyObk) {
		
		EmptyOrderBook obk = new EmptyOrderBook();
		//obk.pointNb ++;
		obk.timeLong = System.nanoTime();
		obk.timeString = sdf.format(new Date());
		obk.nbEmptyObk = nbEmptyObk;
		obk.elapsedTimeMsSinceStart = System.nanoTime() - this.startTime;
		this.emptyOrderBooksList.add(obk);
		
		this.itemNbInList ++;
		this.nbEmptyObkMax = this.calculateMax(); // to size the chart height
	}

	// ***************************************************
	// *** calculate the max nb of empty obks during the session
	// ***************************************************
	public int calculateMax() {
		int max = 0;
		ListIterator<EmptyOrderBook> list_Iter = this.emptyOrderBooksList.listIterator(); 
		while (list_Iter.hasNext()) {
			EmptyOrderBook emptyObk_Itr = list_Iter.next();
			if (emptyObk_Itr.nbEmptyObk > max ) max = emptyObk_Itr.nbEmptyObk;
			}
		return max;
	}
	
    
	// ***************************************************
	// *** WritePlayersListCSVFile
	// ***************************************************	
	public void WritePlayersListCSVFile() {
		try {
	         File f = new File(FILE_EMPTY_OBK_POINTS_NAME);
	         if(!f.exists()) {
	            f.createNewFile();
	         }
	         
			FileWriter fileWriter = new FileWriter(FILE_EMPTY_OBK_POINTS_NAME);
			
			if(f.length() == 0) fileWriter.append(FILE_EMPTY_OBK_POINTS_HEADER);
				
			int i = 0;
	        for (EmptyOrderBook nextObk : this.emptyOrderBooksList) {			
	        		i++;
					String row = 	nextObk.timeString + CSV_SEPARATOR
									+ i + CSV_SEPARATOR		
									+ nextObk.nbEmptyObk 
									+ NEW_LINE_SEPARATOR;
					fileWriter.append(row);
					i++;
						
	        }
	
			fileWriter.flush();
			fileWriter.close();	
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
			String sError =  "catching error: "+ e.toString();
			appLog.logger.warning(sError);
			//JOptionPane.showMessageDialog(controlBoardFrame, "catching error: "+ e.toString()); 
		}		
	}
}
