import java.io.File;
import java.io.FileWriter;
import java.io.IOException;
import java.util.ListIterator;
import java.util.concurrent.CopyOnWriteArrayList;

import javax.swing.JOptionPane;

public class LoginDurationsList {

	public CopyOnWriteArrayList<LoginDuration> loginDurationsList = new CopyOnWriteArrayList<LoginDuration>();
	private ControlBoard controlBoardFrame;
	private Log appLog;
	
	private final static String FILE_LOGIN_DURATION_LIST_NAME = "Login duration stats.csv";
	private final static String NEW_LINE_SEPARATOR ="\n";
	private final static String CSV_SEPARATOR =";";
	private final static String FILE_LOGIN_DURATION_LIST_HEADER = 
														"LoginReq sending Time"+CSV_SEPARATOR
														+ "Login duration (sec)"+CSV_SEPARATOR
														+ "Logout between 2 logins"
														+ NEW_LINE_SEPARATOR;
	// constructor
	public LoginDurationsList(ControlBoard controlBoardFrame, Log appLog) {
		this.controlBoardFrame = controlBoardFrame;
		this.appLog = appLog;
	}
	
	// ***************************************************
	// *** WriteOrderBooksListCSVFile
	// ***************************************************	
	public void WriteCSVFile()  {
		try {
	         File f = new File(FILE_LOGIN_DURATION_LIST_NAME);
	         if(!f.exists()) {
	            f.createNewFile();
	         }
	         
			FileWriter fileWriter = new FileWriter(FILE_LOGIN_DURATION_LIST_NAME);
			
			if(f.length() == 0) fileWriter.append(FILE_LOGIN_DURATION_LIST_HEADER);
				
			ListIterator<LoginDuration> list_Iter = loginDurationsList.listIterator(); 
			while (list_Iter.hasNext()) {
				LoginDuration LoginDuration_Itr = list_Iter.next();
				
				String row = 	LoginDuration_Itr.loginSendingTime_String + CSV_SEPARATOR
								+ LoginDuration_Itr.loginDuration_Sec_String + CSV_SEPARATOR
								+ LoginDuration_Itr.LogoutBetween2Logins
								+ NEW_LINE_SEPARATOR;
				fileWriter.append(row);
				}	
			
			fileWriter.flush();
			fileWriter.close();				
		
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
			String msg = "the " + FILE_LOGIN_DURATION_LIST_NAME + " file cannot be accessed : please check it is well closed."; 
			JOptionPane.showMessageDialog(controlBoardFrame, msg);
			
		}
	}
}
